# Generated by Django 3.2.6 on 2022-02-15 07:24

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('django_rds_iam_auth', '0051_alter_tenant_is_iot_core'),
    ]

    operations = [
        migrations.AddField(
            model_name='tenant',
            name='root_tenant',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='sub_root_tenants', to='django_rds_iam_auth.tenant'),
        ),
        migrations.RunSQL("""
            create function user_has_root_tenant(user_to_check text, tenant_to_check text) returns boolean
                security definer
                language sql
            as
            $$
            select (
                       SELECT tenant_to_check IN (
                           select api_tenant.root_tenant_id
                           from api_user
                                    inner join api_tenant
                                               on api_tenant.id = api_user.origin_tenant_id
                           where api_user.id = user_to_check
                       ) or tenant_to_check = (
                           select origin_tenant_id
                           from api_user
                           where id = user_to_check
                       )
                   ) as result
            $$;
                """, reverse_sql="drop function user_has_root_tenant(text, text);"),
        migrations.RunSQL("""
                    drop policy tenant_table_policy on api_tenant;
                        CREATE POLICY tenant_table_policy ON api_tenant
                            USING (privileged_user_has_tenant(current_user, id) or user_has_root_tenant(current_user, id))
                            with check (privileged_user_has_tenant(current_user, parent_tenant_id));
                    """, reverse_sql="drop policy tenant_table_policy on api_tenant;"),
    ]
