# Generated by Django 3.0.5 on 2022-03-15 08:46

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):
    dependencies = [
        ('django_rds_iam_auth', '0055_auto_20220315_0846'),
    ]

    operations = [
        migrations.RunSQL(sql="DROP POLICY tenant_table_policy ON api_tenant;"),
        migrations.RunSQL(
            sql="""
            create policy select_tenant_table_policy on api_tenant for select
                using (privileged_user_has_tenant((CURRENT_USER)::text, (id)::text) OR
                       user_has_root_tenant((CURRENT_USER)::text, (id)::text));
            create policy update_tenant_table_policy on api_tenant for update
                using (privileged_user_has_tenant((CURRENT_USER)::text, (id)::text) OR
                       user_has_root_tenant((CURRENT_USER)::text, (id)::text))
                with check (privileged_user_has_tenant((CURRENT_USER)::text, (id)::text));
            create policy insert_tenant_table_policy on api_tenant for insert
                with check (privileged_user_has_tenant((CURRENT_USER)::text, (parent_tenant_id)::text));
        """,
            reverse_sql=f"""
                drop policy select_tenant_table_policy on api_tenant;
                drop policy update_tenant_table_policy on api_tenant;
                drop policy insert_tenant_table_policy on api_tenant;
            """,
        ),
    ]
