# Generated by Django 3.0.5 on 2023-01-09 16:12

from django.db import migrations

from django_rds_iam_auth.models import Group
from django.contrib.auth.models import Permission
from django.contrib.contenttypes.models import ContentType


def create_events_permissions(apps, schema_editor):
    content_type = ContentType.objects.get(app_label='django_rds_iam_auth', model='tenant')
    settings_rw, _ = Permission.objects.get_or_create(
        name='Settings management',
        codename='settings-Read&Write',
        content_type=content_type
    )
    tenant_groups = Group.objects.filter(name_alias='TenantAdmin')
    organization_groups = Group.objects.filter(name_alias='OrganizationAdmin')
    for group in tenant_groups:
        group.permissions.add(settings_rw)
    for group in organization_groups:
        group.permissions.add(settings_rw)


class Migration(migrations.Migration):
    dependencies = [
        ('django_rds_iam_auth', '0061_auto_20230103_0709'),
    ]

    operations = [
        migrations.RunPython(create_events_permissions),
        migrations.RunSQL(
            sql="""UPDATE auth_permission SET is_default = false WHERE name = 'Settings management';""",
            reverse_sql="UPDATE auth_permission SET is_default = true WHERE name = 'Settings management';"
        ),
    ]
